<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/


$_SESSION["page"] = "testlog.php";
//include "iocommand.php";
include "fefunctions.php";
$pid = $_REQUEST["pid"];
$language = GetLanguage();

$testLogError = "";
$testLogString = "";
$getTestLogString = sprintf("<getTestLog language='%s'/>", $language);
ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $getTestLogString, $testLogString, $testLogError);

$oss = "";
$oss = sprintf("<html>\n<head>\n  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>\n<TITLE>HP Insight Diagnostics</TITLE>\n");
$oss = $oss . sprintf("<link rel='stylesheet' type='text/css' href='stylesheets/main.css'>\n<SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'>\n</SCRIPT>\n");
$oss = $oss . sprintf("</HEAD>\n</head>\n<body onload='doLogMenuItem(0)'>\n<form name=testLogForm action=testlog.php method=POST>\n");

$oss = $oss . sprintf("<div id='savePrompt' style='Visibility:hidden; display:none;'><table width=100%%>\n  <tr>\n");
$oss = $oss . sprintf("    <td width=300></td>\n<td>");

$oss = $oss . sprintf("                                 <br><input type='radio' name='location' value='floppy'> %s\n", TR("MSG_SAVE_TO_FLOPPY"));

if (IsOnline())
  $oss = $oss . sprintf("    <input type='radio' name='location' value='harddrive'> %s %s<br>\n", TR("MSG_SAVE_TO_HARD_DRIVE"), $_SESSION["diagsDirectory"]);

if (mountUSB("Transparent SCSI"))
  $oss = $oss . sprintf("                                 <br><input type='radio' name='location' value='usb'> %s\n", TR("MSG_SAVE_TO_USB_KEY"));

if (mountUSB("Floppy"))
{
  $usbFloppy = true;
  $oss = $oss . sprintf("                                 <br><input type='radio' name='location' value='usb'> %s\n", TR("MSG_SAVE_TO_USB_FLOPPY"));
}

$oss = $oss . sprintf("    </td><td align=right><b>%s:</b> <input type=text name=filename onKeyPress='return submitenter(\"2\");'> ", TR("MSG_FILENAME"));
$oss = $oss . sprintf("<input type=button value=%s onclick='saveFile(\"2\");'></td>\n  </tr>\n</table>\n<hr>\n</div>\n", TR("MSG_SAVE"));


$oss = $oss . sprintf("<table>\n  <tr valign=top>\n    <td class='head'>%s</td>\n  </tr>\n</table><hr>\n", TR("MSG_TEST_LOG"));
$oss = $oss . sprintf("<table width=100%%>\n  <tr class=heading>\n    <td class=heading width=500>%s, %s</td>\n", TR("MSG_DEVICE"), TR("MSG_TEST"));
$oss = $oss . sprintf("    <td class=heading width=150 align=center>%s</td>\n", TR("MSG_NUMBER_OF_TIMES_TESTED"));
$oss = $oss . sprintf("    <td class=heading width=100 align=center>%s</td>\n", TR("MSG_NUMBER_OF_ERRORS"));
$oss = $oss . sprintf("    <td class=heading width=100 align=center>%s</td>\n  </tr>\n</table>\n", TR("MSG_TEST_TIME"));
$oss = $oss . sprintf("<div style='height:310px;overflow:auto'>\n<table width=100%%>\n");


if ($_REQUEST["clear"] == "1") // if user clicked the Clear button
{
  $clearError = "";
  $testLogString = "";
  $clearLogString = sprintf("<clearTestLog language='%s'/>", $language);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $clearLogString, $testLogString, $clearError);
}

if ($testLogString != "")
{
  $xmldoc = @new DomDocument($testLogString);
  $rootElement = @$xmldoc->document_element();
  //echo htmlentities($xmldoc->html_dump_mem());

  $rowColor = "";
  $testLogXpath = @xpath_new_context($xmldoc->document_element());
  $testLogRecords = @xpath_eval($testLogXpath, "/testLogRecord");
  $num_testLogRecords = count($testLogRecords->nodeset); // should only be 1 - replace with find first match if possible
  for ($i=0; $i < $num_testLogRecords; $i++)
  {
    $testLogRecord = $testLogRecords->nodeset[$i];
    $testCaption = $testLogRecord->get_attribute("testCaption");
    $testTime = $testLogRecord->get_attribute("testTime");
    $passedCount = $testLogRecord->get_attribute("passedCount");
    $failedCount = $testLogRecord->get_attribute("failedCount");
      $oss = $oss . sprintf("  <tr bgcolor='%s'>\n", $rowColor);
    if ($failedCount)
      $gif = "failed.gif";
    else
      $gif = "ok.gif";
      $oss = $oss . sprintf("    <td width=500><img src='%s'>&nbsp;&nbsp;%s</td>\n", $gif, $testCaption);
    if (!$failedCount)
      $failedCount = 0;
    $timesTested = $passedCount + $failedCount;
      $oss = $oss . sprintf("    <td width=150 align=center>%d</td>\n", $timesTested);
    $oss = $oss . sprintf("    <td width=100 align=center>%d</td>\n", $failedCount);
      $oss = $oss . sprintf("    <td width=100 align=center>%s</td>\n  </tr>\n", $testTime);

      // Alternate the row color
    if($rowColor == "")
      $rowColor = "#eeeeee"; // make gray
    else
      $rowColor = ""; // make white

  }
  $oss = $oss . sprintf("</table>\n<div>\n");
}

$oss = $oss . sprintf("</table>\n");


if ($HTTP_POST_VARS["save"] == "3")  
{ // Save page
  $result = SaveFile($HTTP_POST_VARS["filename"],$HTTP_POST_VARS["saveLocation"], "HP Insight Diagnostics " . TR("MSG_VERSION") . " " . getBuildVersion() . "<br>" . TR("Computer Name") . ": " . getComputerName() . $oss);
  
  if ($result == 1 || $result == 3)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_PLEASE_INSERT_FLOPPY"));
  else if ($result == 2)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_DISK_FULL"));
  else if ($result == 4)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_BAD_FORMAT"));
  else
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s');\n</script>\n", TR("MSG_FILE_WRITE_COMPLETE"));
}

if ($num_testLogRecords) // put it here so we do not write it to the file when saving
  $oss = $oss . sprintf("<table width=100%%><tr><td align=center>%s</td></tr>", MakeButton(TR("MSG_CLEAR_TEST_LOG"),"document.location='testlog.php?clear=1'"));
				

//hidden variables
$oss = $oss . sprintf("<input type=hidden name=save value=0>\n");
$oss = $oss . sprintf("<input type=hidden name=saveLocation value='floppy'>\n");

$oss = $oss . sprintf("<SCRIPT Language='Javascript'>\n");
$oss = $oss . sprintf("function saveFile(s)\n{\n");
$oss = $oss . sprintf("  if (s == 2 && document.testLogForm.filename.value == '')\n{\n");
$oss = $oss . sprintf("    alert('%s');\n", TR("MSG_PLEASE_ENTER_FILENAME"));
$oss = $oss . sprintf("    return;\n }\n");

if (IsOnline())
{
  $oss = $oss . sprintf("    if (document.testLogForm.location[1].checked)\n{\n");
  $oss = $oss . sprintf("      document.testLogForm.saveLocation.value = 'harddrive';\n}\n");
}
else if (mountUSB("Transparent SCSI"))
{
  $oss = $oss . sprintf("    if (document.testLogForm.location[1].checked)\ndocument.testLogForm.saveLocation.value = 'diskonkey';\n");
  if ($usbFloppy)
    $oss = $oss . sprintf("    if (document.testLogForm.location[2].checked)\ndocument.testLogForm.saveLocation.value = 'usb';\n");
}
else if ($usbFloppy)
  $oss = $oss . sprintf("    if (document.testLogForm.location[1].checked)\ndocument.testLogForm.saveLocation.value = 'usb';\n");

$oss = $oss . sprintf("  document.testLogForm.save.value = s;\n");
$oss = $oss . sprintf("  document.testLogForm.submit();\n}\n");


if ($HTTP_POST_VARS["save"] == "2")  // check if file exits
{
  if ($HTTP_POST_VARS["saveLocation"] == "floppy")
  {
    if ($os == "Linux" || $os == "Unix" || !IsOnline())
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount " . getPathToFloppy() . "</systemCall>", $returnString, $systemCallError);
    $fileP = getPathToFloppy() . $HTTP_POST_VARS["filename"];
  }
  else if ($HTTP_POST_VARS["saveLocation"] == "usb")
  {  
    if ($os == "Linux" || $os == "Unix")
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount /mnt/diskonkey</systemCall>", $returnString, $systemCallError);
    $fileP = "/mnt/diskonkey" . $HTTP_POST_VARS["filename"];
  }
  else if ($HTTP_POST_VARS["saveLocation"] == "usb")
  {
    $fileP = "/mnt/usb/" . $HTTP_POST_VARS["filename"];
  }
  else
    $fileP = $_SESSION["diagsDirectory"] . $HTTP_POST_VARS["filename"];

  if (file_exists($fileP))
  {
    $oss = $oss . sprintf("if  (!window.confirm('Saving will overwrite the existing file. Do you wish to continue?'))\n{");
    $oss = $oss . sprintf("    \n  document.testLogForm.save.value=0;\n");
    $oss = $oss . sprintf("    document.testLogForm.submit();\n   }\n");
    $oss = $oss . sprintf("else\n");
    $oss = $oss . sprintf("{\n");
    $oss = $oss . sprintf("  document.testLogForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
    $oss = $oss . sprintf("  document.testLogForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
    $oss = $oss . sprintf("  saveFile(3);\n}\n");

  }
  else
  {
    $oss = $oss . sprintf("  document.testLogForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
    $oss = $oss . sprintf("  document.testLogForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
    $oss = $oss . sprintf("  saveFile(3);\n");
  } 
   
}
if ($HTTP_POST_VARS["save"] == "1") // keep savePrompt displayed
  $oss = $oss . sprintf("document.getElementById('savePrompt').style.display = 'inline';\ndocument.getElementById('savePrompt').style.visibility = 'visible';\n");

$oss = $oss . sprintf("</script>\n");

$oss = $oss . sprintf("</form>\n<script language='Javascript' src='norightclick.js'></script></body>\n</html>\n");

printf("%s", $oss);
?>
